Package org.codehaus.janino

# Class Java.Crement

java.lang.Object
org.codehaus.janino.Java.Located
org.codehaus.janino.Java.Atom
org.codehaus.janino.Java.Rvalue
org.codehaus.janino.Java.Crement

All Implemented Interfaces:
  `Java.ArrayInitializerOrRvalue`, `Java.ElementValue`, `Java.Locatable`

Enclosing class:
  `Java`

public static final class Java.Crement extends Java.Rvalue
Representation of a JLS7 15.14.2 "postfix increment operation", a JLS7 15.14.3 "postfix decrement operation", a JLS7 15.15.1 "prefix increment operation" or a JLS7 15.15.2 "prefix decrement operation".

## Field Summary

Fields
Modifier and Type
Field
Description
`final Java.Lvalue`
`operand`
The lvalue to operate upon.
`final String`
`operator`
The operator; either `"++"` or `"--"`, as an `interned` string.
`final boolean`
`pre`
Whether this operation is "pre" (TRUE) or "post" (FALSE).

### Fields inherited from class org.codehaus.janino.Java.Located

`NOWHERE`

## Constructor Summary

Constructors
Constructor
Description
`Crement(Location location, String operator, Java.Lvalue operand)`
`Crement(Location location, Java.Lvalue operand, String operator)`

## Method Summary

Modifier and Type
Method
Description
`<R, EX extends Throwable>
R`
`accept(Visitor.RvalueVisitor<R,EX> visitor)`
Invokes the "`visit...()`" method of `Visitor.RvalueVisitor` for the concrete `Java.Rvalue` type.
`String`
`toString()`

### Methods inherited from class org.codehaus.janino.Java.Rvalue

`accept, accept, accept, getEnclosingScope, getEnclosingScopeOrNull, setEnclosingScope, toRvalue`

### Methods inherited from class org.codehaus.janino.Java.Atom

`toLvalue, toLvalueOrCompileException, toRvalueOrCompileException, toType, toTypeOrCompileException`

### Methods inherited from class org.codehaus.janino.Java.Located

`getLocation, throwCompileException`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.codehaus.janino.Java.Locatable

`getLocation, throwCompileException`

## Field Details

### pre

public final boolean pre
Whether this operation is "pre" (TRUE) or "post" (FALSE).

### operator

public final String operator
The operator; either `"++"` or `"--"`, as an `interned` string.

### operand

public final Java.Lvalue operand
The lvalue to operate upon.

## Constructor Details

### Crement

public Crement(Location location, String operator, Java.Lvalue operand)

Parameters:
  `operator` - Must be either `"++"` or `"--"`, as an `interned` string

### Crement

public Crement(Location location, Java.Lvalue operand, String operator)

Parameters:
  `operator` - Must be either `"++"` or `"--"`, as an `interned` string

## Method Details

### toString

public String toString()

Specified by:
  `toString` in class `Java.Atom`

### accept

@Nullable public <R, EX extends Throwable> R accept(Visitor.RvalueVisitor<R,EX> visitor) throws EX
Description copied from class: `Java.Rvalue`
Invokes the "`visit...()`" method of `Visitor.RvalueVisitor` for the concrete `Java.Rvalue` type.

Specified by:
  `accept` in class `Java.Rvalue`
Throws:
  `EX`